var localTime = new Date();
var dayInMilliSeconds = 24*60*60*1000;
var milliSecondsDiff;

 

var users;
var user;
var firstname;
var usrUserName;
var cmUserName;
var email;
var daysleft;
var subject1 = "EisenVault : Password Expiring Notification";
var subject2 = "EisenVault : Password Expired";
var getPassExpiryDate;
var passIsExpired = false;
//fetch all the user nodes (@usr) - there are always two nodes for every user, i.e, person node(cm:tester1) and a user node(usr:tester1)
var nodes = people.getPeople(null);
var userNodes = search.luceneSearch("user://alfrescoUserStore", "@usr\\:username:\*");

 

for each(var userNode in userNodes)
{
    logger.log(userNode);
    users = userNode;
    getPassExpiryDate = users.properties["usr:credentialsExpiryDate"];
    usrUserName = users.properties["usr:username"];
    
    checkPasswordExpiration(getPassExpiryDate);
}

 


function checkPasswordExpiration(passExpiryDate){
    if(passExpiryDate != null)
    {
        milliSecondsDiff = passExpiryDate.getTime() - localTime.getTime();
        getUserProperties();
        
        // sending mail 7 days before password expiration
        if(milliSecondsDiff < dayInMilliSeconds*7 && milliSecondsDiff > dayInMilliSeconds*6)
        {
            daysleft = 7;    
            sendEmailNotification("password-expiring.html.ftl", subject1);
        }
        // sending mail 3 days before password expiration
        if(milliSecondsDiff < dayInMilliSeconds*3 && milliSecondsDiff > dayInMilliSeconds*2)
        {
            daysleft = 3;    
            sendEmailNotification("password-expiring.html.ftl", subject1);
        }
            // sending mail 1 days before password expiration
        if(milliSecondsDiff < dayInMilliSeconds*2 && milliSecondsDiff > dayInMilliSeconds*1)
        {
            daysleft = 1;
            sendEmailNotification("password-expiring.html.ftl", subject1);
        }
        // sending mail notification on the same day - on the password expiration day            
        if(milliSecondsDiff < dayInMilliSeconds  && milliSecondsDiff > 0)
        {
            daysleft = 0;        
            sendEmailNotification("password-expiring.html.ftl", subject1);
        }
        // sending mail notification if password is expired.            
        if(milliSecondsDiff <= 0)
        {
            daysleft = 0;            
            sendEmailNotification("password-expired.html.ftl", subject2);
        }
    }
    
}
    
function sendEmailNotification(templateName, subject) {
    try {
        var template = emailHelper.getLocalizedEmailTemplate("app:dictionary/app:email_templates/cm:" + templateName);
        }
    catch (e) {
            throw e.javaException.getMessage();
        }
    
    var mail = actions.create("mail");
    mail.parameters.template = template;
    mail.parameters.to = email;
    mail.parameters.from = "no-reply@eisenvault.com";
    mail.parameters.subject = subject;
    var templateModel = new Array();
    templateModel['firstname'] = firstname;
    if(daysleft != 0){
    templateModel['days'] = daysleft;
    }
    mail.parameters.template_model = templateModel;
    
    try {
            mail.execute(userNode);
        }
    catch (ex) {
            throw "Failed to send email. Please, check outbound email configuration.\n\n ";
            
        }
};
    
function getUserProperties(){
        
       for each(var node in nodes)
       {
           logger.log(node);
           user = utils.getNodeFromString(node);        
           cmUserName = user.properties["cm:userName"];
           
           if(cmUserName == usrUserName){
               firstname = user.properties["cm:firstName"];
               email = user.properties["cm:email"];
               logger.log("\n\n      cmUserName : " + cmUserName + "  -  firstname : " + firstname + "  -  email : " + email + "\n-------------------------------------------------------\n\n");
           }           
       }
};